#include <iostream>
#include <ctime>

#define T 1000
#define K 3
#define N 6

using namespace std;


int main() {
	cout << "\n=======================================================\n"
			"Zadatak 1\n"
			"=======================================================\n";

	srand(time(nullptr));
	bool matrix[K][N] = {{false, true, false, true,  false, true},
						 {true,  true, true,  true,  true,  true},
						 {false, true, true,  false, false, true}};

	bool bit;
	int tezina[8] = {0};
	int tezine[8] = {0};

	int i = 0;

	cout << "\nKodne reci:\n";
	for (int a = 0; a < 2; a++) {
		for (int b = 0; b < 2; b++) {
			for (int c = 0; c < 2; c++) {
				for (int j = 0; j < N; j++) {
					if ((bit = a & matrix[0][j] ^ b & matrix[1][j] ^ c & matrix[2][j])) tezina[i]++;
					cout << bit;
				}
				cout << " - d = " << tezina[i] << endl;
				tezine[tezina[i++]]++;
			}
		}
	}

	int d = 0;
	cout << "\nBroj kodnih reci sa tezinom:\n";
	for (int j = 0; j <= N; j++) {
		cout << "d = " << j << " - " << tezine[j] << endl;
		if (!d && j && tezine[j]) d = j;
	}

	int g = -1;
	int c = -1;

	while (d >= 2 * (++c + 1) + 1);
	while (d >= c + (++g + 1) + 1);

	cout << "\nOvaj kod moze da detektuje " << g << " gresku, a ispravi " << c << " gresaka.\n\n";

	cout << "=======================================================\n"
			"Zadatak 2\n"
			"=======================================================\n"
			"Usvaja se nova generisuca matrica posto prosla nema sposobnost ispravke grekse.\n";

	bool generisuca[K][N] = {{false, false, false, true,  true,  true},
							 {false, true,  true,  false, false, true},
							 {true,  false, true,  false, true,  false}};

	bool kontrolna[N][K] = {{true,  true,  false},
							{true,  false, true},
							{true,  false, false},
							{false, true,  true},
							{false, true,  false},
							{false, false, true}};

	bool izvor[K * T];

	bool zasticenaPredajnik[N * T];
	int predajnikCounter = 0;

	bool interliver[T][N];
	int interliverPara;

	bool kanal[N * T];
	int kanalCounter = 0;
	int greska;

	bool deinterliver[T][N];

	bool zasticenaPrijemnik[N * T];
	int prijemnikCounter = 0;

	int sindrom;

	int brojGresaka = 0;

	cout << "\nOd kog bita unositi paket od 4 greske na svakih 100 bitova? ";
	cin >> greska;
	cout << "Koje parametre interlivera koristiti (1000 mora biti deljiv ovim brojem)? ";
	cin >> interliverPara;

	cout << "\nIzvor:\n"
			"===================================\n";
	for (int j = 0; j < K * T; j++) {                            // Izvor
		izvor[j] = rand() % 2;
		cout << izvor[j];
		if (j % 3 == 2) cout << " \n"[(j + 3) % 54 == 2];
	}

	cout << "\n\nGenerisane kodne reci:\n"
			"===================================\n";
	for (int p = 0; p < K * T; p += 3) {                        // Zastitni koder
		for (int j = 0; j < N; j++) {
			zasticenaPredajnik[predajnikCounter] =
					izvor[p + 0] & generisuca[0][j] ^
					izvor[p + 1] & generisuca[1][j] ^
					izvor[p + 2] & generisuca[2][j];
			cout << zasticenaPredajnik[predajnikCounter++];
		}
		cout << " \n"[(p + 3) % 24 == 0];
	}

	for (int p = 0; p < predajnikCounter;) {                    // Interliver
		for (int j = 0; j < interliverPara; j++) {                // Punjenje interlivera
			for (int k = 0; k < 6; k++) {
				interliver[j][k] = zasticenaPredajnik[p++];
			}
		}

		for (int j = 0; j < 6; j++) {                            // Praznjenje interlivera
			for (int k = 0; k < interliverPara; k++) {
				kanal[kanalCounter++] = interliver[k][j];
			}
		}
	}

	for (int o = greska - 100; o < kanalCounter; o += 100) {    // Greska u kanalu
		kanal[o - 1] ^= true;
		kanal[o + 0] ^= true;
		kanal[o + 1] ^= true;
		kanal[o + 2] ^= true;
	}

	for (int p = 0; p < kanalCounter;) {                        // Deinterliver
		for (int j = 0; j < 6; j++) {                            // Punjenje deintelivera
			for (int k = 0; k < interliverPara; k++) {
				deinterliver[k][j] = kanal[p++];
			}
		}

		for (int j = 0; j < interliverPara; j++) {                // Praznjenje deinterlivera
			for (int k = 0; k < 6; k++) {
				zasticenaPrijemnik[prijemnikCounter++] = deinterliver[j][k];
			}
		}
	}

	for (int p = 0; p < 6 * T; p += 6) {                                // Dekoder
		sindrom = 0;
		for (int j = 0; j < 3; j++) {                                    // Racunjanje sindroma
			sindrom += !(zasticenaPrijemnik[p + 0] & kontrolna[0][j] ^
						 zasticenaPrijemnik[p + 1] & kontrolna[1][j] ^
						 zasticenaPrijemnik[p + 2] & kontrolna[2][j] ^
						 zasticenaPrijemnik[p + 3] & kontrolna[3][j] ^
						 zasticenaPrijemnik[p + 4] & kontrolna[4][j] ^
						 zasticenaPrijemnik[p + 5] & kontrolna[5][j]) * (int) pow(2, 2 - j);
		}
		if (sindrom != 0 && sindrom != 7) zasticenaPrijemnik[p + sindrom - 1] ^= true;        // Korekcija greske
	}

	cout << "\nDekodovana[Original]\n"
			"===================================\n";
	for (int p = 0; p < N * T; p += 6) {
		if (zasticenaPrijemnik[p + 3] != izvor[p / 2] || zasticenaPrijemnik[p + 1] != izvor[p / 2 + 1] ||
			zasticenaPrijemnik[p] != izvor[p / 2 + 2])
			brojGresaka++;
		cout << zasticenaPrijemnik[p + 3] << zasticenaPrijemnik[p + 1] << zasticenaPrijemnik[p]
			 << "[" << izvor[p / 2] << izvor[p / 2 + 1] << izvor[p / 2 + 2] << "]" << " \n"[(p + 6) % 16 == 0];
	}

	cout << "\nProcenat lose prenesenih bitova je " << 100 * brojGresaka / T << "%!";
}